diff -urN linux-2.4.21/drivers/mtd/chips/cfi_probe.c linux-2.4.21.zipit/drivers/mtd/chips/cfi_probe.c
--- linux-2.4.21/drivers/mtd/chips/cfi_probe.c	2005-02-07 11:17:13.033302709 -0500
+++ linux-2.4.21.zipit/drivers/mtd/chips/cfi_probe.c	2004-03-15 14:52:58.000000000 -0500
@@ -65,10 +65,6 @@
 		return 0;
 	}
 	cfi_send_gen_cmd(0xF0, 0, base, map, cfi, cfi->device_type, NULL);
-
-	/* some devices don't respond to 0xF0, so send 0xFF to be sure */
-	cfi_send_gen_cmd(0xFF, 0, base, map, cfi, cfi->device_type, NULL);
-
 	cfi_send_gen_cmd(0x98, 0x55, base, map, cfi, cfi->device_type, NULL);
 
 	if (!qry_present(map,base,cfi))
@@ -88,8 +84,6 @@
 			/* Eep. This chip also had the QRY marker. 
 			 * Is it an alias for the new one? */
 			cfi_send_gen_cmd(0xF0, 0, chips[i].start, map, cfi, cfi->device_type, NULL);
-			/* some devices don't respond to 0xF0, so send 0xFF to be sure */
-			cfi_send_gen_cmd(0xFF, 0, chips[i].start, map, cfi, cfi->device_type, NULL);
 
 			/* If the QRY marker goes away, it's an alias */
 			if (!qry_present(map, chips[i].start, cfi)) {
@@ -102,8 +96,7 @@
 			 * too and if it's the same, assume it's an alias. */
 			/* FIXME: Use other modes to do a proper check */
 			cfi_send_gen_cmd(0xF0, 0, base, map, cfi, cfi->device_type, NULL);
-			/* some devices don't respond to 0xF0, so send 0xFF to be sure */
-			cfi_send_gen_cmd(0xFF, 0, base, map, cfi, cfi->device_type, NULL);
+			
 			if (qry_present(map, base, cfi)) {
 				printk(KERN_DEBUG "%s: Found an alias at 0x%x for the chip at 0x%lx\n",
 				       map->name, base, chips[i].start);
@@ -126,10 +119,6 @@
 	/* Put it back into Read Mode */
 	cfi_send_gen_cmd(0xF0, 0, base, map, cfi, cfi->device_type, NULL);
 
-	/* some devices don't respond to 0xF0, so send 0xFF to be sure */
-	cfi_send_gen_cmd(0xFF, 0, base, map, cfi, cfi->device_type, NULL);
-
-
 	printk(KERN_INFO "%s: Found %d x%d devices at 0x%x in %d-bit mode\n",
 	       map->name, cfi->interleave, cfi->device_type*8, base,
 	       map->buswidth*8);
@@ -176,20 +165,6 @@
 	cfi->cfiq->InterfaceDesc = le16_to_cpu(cfi->cfiq->InterfaceDesc);
 	cfi->cfiq->MaxBufWriteSize = le16_to_cpu(cfi->cfiq->MaxBufWriteSize);
 
-	/*
-	 * ST screwed up the CFI interface for buffer writes on their parts,
-	 * so this needs to be fixed up by hand here.
-         *
-         * A possible enhancment is that instead of just reverting back
-         * to word write (as this does), we could use the ST specific double
-         * word write instead.
-	 */
-
-	if (cfi_read_query(map,base) == 0x20){
-	  cfi->cfiq->BufWriteTimeoutTyp = 0;
-	  cfi->cfiq->BufWriteTimeoutMax = 0;
-	}
-
 #ifdef DEBUG_CFI
 	/* Dump the information therein */
 	print_cfi_ident(cfi->cfiq);
@@ -207,9 +182,6 @@
 	/* Put it back into Read Mode */
 	cfi_send_gen_cmd(0xF0, 0, base, map, cfi, cfi->device_type, NULL);
 
-	/* some devices don't respond to 0xF0, so send 0xFF to be sure */
-	cfi_send_gen_cmd(0xFF, 0, base, map, cfi, cfi->device_type, NULL);
-
 	return 1;
 }
 

