diff -urN linux-2.4.21/drivers/mtd/maps/physmap.c linux-2.4.21.zipit/drivers/mtd/maps/physmap.c
--- linux-2.4.21/drivers/mtd/maps/physmap.c	2003-06-13 10:51:34.000000000 -0400
+++ linux-2.4.21.zipit/drivers/mtd/maps/physmap.c	2004-03-15 14:52:58.000000000 -0500
@@ -121,8 +121,11 @@
 	const char **type;
 
        	printk(KERN_NOTICE "physmap flash device: %x at %x\n", WINDOW_SIZE, WINDOW_ADDR);
+#ifdef CONFIG_ARCH_ZIPLINE 
+	physmap_map.map_priv_1 = (unsigned long)ioremapi_nocache(WINDOW_ADDR, WINDOW_SIZE);
+#else
 	physmap_map.map_priv_1 = (unsigned long)ioremap(WINDOW_ADDR, WINDOW_SIZE);
-
+#endif
 	if (!physmap_map.map_priv_1) {
 		printk("Failed to ioremap\n");
 		return -EIO;

