diff -urN linux-2.4.21/drivers/mtd/mtdblock.c linux-2.4.21.zipit/drivers/mtd/mtdblock.c
--- linux-2.4.21/drivers/mtd/mtdblock.c	2003-06-13 10:51:34.000000000 -0400
+++ linux-2.4.21.zipit/drivers/mtd/mtdblock.c	2004-03-15 14:52:58.000000000 -0500
@@ -521,6 +521,8 @@
 
 static void mtdblock_request(RQFUNC_ARG)
 {
+	printk(KERN_ERR "we are in mtdblock_request");
+
 	/* Don't do anything, except wake the thread if necessary */
 	wake_up(&thr_wq);
 }
@@ -618,6 +620,7 @@
 {
 	int i;
 
+
 	spin_lock_init(&mtdblks_lock);
 #ifdef CONFIG_DEVFS_FS
 	if (devfs_register_blkdev(MTD_BLOCK_MAJOR, DEVICE_NAME, &mtd_fops))
@@ -642,12 +645,21 @@
 		mtd_sizes[i] = 0;
 		mtd_blksizes[i] = BLOCK_SIZE;
 	}
+	DEBUG(MTD_DEBUG_LEVEL2, "mtdblock: init_mtdblock");
 	init_waitqueue_head(&thr_wq);
 	/* Allow the block size to default to BLOCK_SIZE. */
 	blksize_size[MAJOR_NR] = mtd_blksizes;
 	blk_size[MAJOR_NR] = mtd_sizes;
 	
+	DEBUG(MTD_DEBUG_LEVEL2, "mtdblock: blk_init_queue: 0x%08lX", &mtdblock_request);
+	
+	{
+	request_queue_t *q = BLK_DEFAULT_QUEUE(MAJOR_NR);
+	printk(KERN_ERR "q: 0x%08lX, &head: 0x%08lX, &elevator: 0x%08lX", q, &q->queue_head, &q->elevator);
+
+	}
 	blk_init_queue(BLK_DEFAULT_QUEUE(MAJOR_NR), &mtdblock_request);
+	DEBUG(MTD_DEBUG_LEVEL2, "mtdblock: init_mtdblock");
 	kernel_thread (mtdblock_thread, NULL, CLONE_FS|CLONE_FILES|CLONE_SIGHAND);
 	return 0;
 }

