diff -urN linux-2.4.21/drivers/net/cirrus.c linux-2.4.21.zipit/drivers/net/cirrus.c
--- linux-2.4.21/drivers/net/cirrus.c	2005-02-07 11:17:13.120294754 -0500
+++ linux-2.4.21.zipit/drivers/net/cirrus.c	2004-03-15 14:52:28.000000000 -0500
@@ -67,6 +67,9 @@
 #elif CONFIG_ARCH_CDB89712
 #	define CIRRUS_DEFAULT_IO ETHER_BASE + 0x300
 #	define CIRRUS_DEFAULT_IRQ IRQ_EINT3
+#elif CONFIG_ARCH_ZIPLINE
+#	define CIRRUS_DEFAULT_IO ZIPLINE_VIRT_CS8900A
+#	define CIRRUS_DEFAULT_IRQ IRQ_EINT3
 #else
 #	define CIRRUS_DEFAULT_IO	0
 #	define CIRRUS_DEFAULT_IRQ	0
@@ -621,6 +624,7 @@
 		return (-EINVAL);
 	}
 
+#ifndef CONFIG_ARCH_ZIPLINE
 	if ((result = check_region (dev->base_addr,16))) {
 		printk (KERN_ERR "%s: can't get I/O port address 0x%lx\n",dev->name,dev->base_addr);
 		return (result);
@@ -628,16 +632,27 @@
 
 	if (!request_region (dev->base_addr,16,dev->name))
 		return -EBUSY;
-
+#endif
 #ifdef CONFIG_SA1100_FRODO
 	frodo_reset (dev);
 #endif	/* #ifdef CONFIG_SA1100_FRODO */
 
+#ifdef CONFIG_ARCH_ZIPLINE
+	{
+		char ZIPLINE[] = { 0,1,2,3,4,5 };
+
+		for (i=0; i < ETH_ALEN; i++)
+		{
+		        dev->dev_addr[i] = ZIPLINE[i];
+		}
+		printk(KERN_WARNING "cs89x0: No EEPROM, hacked in ETHERNET ADDRESS....\n");
+	}
+#else
 	/* if an EEPROM is present, use it's MAC address */
 	if (!cirrus_eeprom (dev,&eeprom))
 		for (i = 0; i < 6; i++)
 			dev->dev_addr[i] = eeprom.mac[i];
-
+#endif
 	/* verify EISA registration number for Cirrus Logic */
 	if ((value = cirrus_read (dev,PP_ProductID)) != EISA_REG_CODE) {
 		printk (KERN_ERR "%s: incorrect signature 0x%.4x\n",dev->name,value);
@@ -675,7 +690,9 @@
 
 static void __exit cirrus_cleanup (void)
 {
+#ifndef CONFIG_ARCH_ZIPLINE
 	release_region (dev.base_addr,16);
+#endif
 	unregister_netdev (&dev);
 }
 

