diff -urN linux-2.4.21/drivers/serial/clps711x.c linux-2.4.21.zipit/drivers/serial/clps711x.c
--- linux-2.4.21/drivers/serial/clps711x.c	2005-02-07 11:17:13.529257357 -0500
+++ linux-2.4.21.zipit/drivers/serial/clps711x.c	2004-03-15 14:53:02.000000000 -0500
@@ -434,7 +434,11 @@
 	{
 		.iobase		= SYSCON1,
 		.irq		= IRQ_UTXINT1, /* IRQ_URXINT1, IRQ_UMSINT */
-		.uartclk	= 3686400,
+#ifdef CONFIG_ZIPLINE_90MHZ
+		uartclk:	4515840,
+#else
+		uartclk:	3686400,
+#endif /* CONFIG_ZIPLINE_90MHZ */
 		.fifosize	= 16,
 		.ops		= &clps711x_pops,
 		.line		= 0,
@@ -443,7 +447,11 @@
 	{
 		.iobase		= SYSCON2,
 		.irq		= IRQ_UTXINT2, /* IRQ_URXINT2 */
-		.uartclk	= 3686400,
+#ifdef CONFIG_ZIPLINE_90MHZ
+		uartclk:	4515840,
+#else
+		uartclk:	3686400,
+#endif /* CONFIG_ZIPLINE_90MHZ */
 		.fifosize	= 16,
 		.ops		= &clps711x_pops,
 		.line		= 1,
@@ -529,7 +537,33 @@
 			*bits = 8;
 
 		quot = ubrlcr & UBRLCR_BAUD_MASK;
+#ifdef CONFIG_ZIPLINE_90MHZ
+		switch(quot)
+		{
+			case 4:
+				*baud = 57600;
+				break;
+
+			case 14:
+				*baud = 19200;
+				break;
+
+			case 19:
+				*baud = 14400;
+				break;
+
+			case 58:
+				*baud = 4800;
+				break;
+
+			case 28:
+			default:
+				*baud = 9600;
+				break;
+		}
+#else
 		*baud = port->uartclk / (16 * (quot + 1));
+#endif /* CONFIG_ZIPLINE_90MHZ */
 	}
 }
 

