diff -urN linux-2.4.21/drivers/serial/core.c linux-2.4.21.zipit/drivers/serial/core.c
--- linux-2.4.21/drivers/serial/core.c	2005-02-07 11:17:13.541256260 -0500
+++ linux-2.4.21.zipit/drivers/serial/core.c	2004-03-15 14:53:02.000000000 -0500
@@ -352,8 +352,11 @@
 	    ((port->flags & ASYNC_SPD_MASK) == ASYNC_SPD_CUST))
 		quot = port->custom_divisor;
 	else
+#ifdef CONFIG_ZIPLINE_90MHZ
+		quot = (((port->uartclk * 10) / (16 * baud)) + 5) / 10;
+#else
 		quot = port->uartclk / (16 * baud);
-
+#endif /*CONFIG_ZIPLINE_90MHZ*/
 	return quot;
 }
 
@@ -402,7 +405,7 @@
 		termios->c_cflag |= B9600;
 	}
 
-	uart_update_timeout(port, cflag, port->uartclk / (16 * quot));
+	uart_update_timeout(port, cflag, baud);
 
 	if (termios->c_cflag & CRTSCTS)
 		state->info->flags |= UIF_CTS_FLOW;
@@ -1926,7 +1929,7 @@
 	if (flow == 'r')
 		termios.c_cflag |= CRTSCTS;
 
-	quot = (port->uartclk / (16 * baud));
+	quot = uart_calculate_quot(port, baud);
 	port->ops->change_speed(port, termios.c_cflag, 0, quot);
 	co->cflag = termios.c_cflag;
 

