diff -urN linux-2.4.21/include/asm-arm/arch-clps711x/hardware.h linux-2.4.21.zipit/include/asm-arm/arch-clps711x/hardware.h
--- linux-2.4.21/include/asm-arm/arch-clps711x/hardware.h	2005-02-07 11:17:14.000000000 -0500
+++ linux-2.4.21.zipit/include/asm-arm/arch-clps711x/hardware.h	2004-04-20 12:46:41.000000000 -0400
@@ -65,6 +65,10 @@
 #define EP7212_BASE		CLPS7111_VIRT_BASE
 #include <asm/hardware/ep7212.h>
 
+#elif defined (CONFIG_ARCH_ZIPLINE)
+#define ZIPLINE_VIRT_BASE	CLPS7111_VIRT_BASE
+#define ZIPLINE_BASE		CLPS7111_VIRT_BASE
+#include <asm/hardware/zipline.h>
 
 #endif
 
@@ -136,10 +140,10 @@
 #if defined (CONFIG_ARCH_EDB7211)
 
 /*
- * The extra 8 lines of the keyboard matrix are wired to chip select 3 (nCS3) 
+ * The extra 8 lines of the keyboard matrix are wired to chip select 3 (nCS3)
  * and repeat across it. This is the mapping for it.
  *
- * In jumpered boot mode, nCS3 is mapped to 0x4000000, not 0x3000000. This 
+ * In jumpered boot mode, nCS3 is mapped to 0x4000000, not 0x3000000. This
  * was cause for much consternation and headscratching. This should probably
  * be made a compile/run time kernel option.
  */
@@ -149,10 +153,10 @@
 
 
 /*
- * The CS8900A ethernet chip has its I/O registers wired to chip select 2 
+ * The CS8900A ethernet chip has its I/O registers wired to chip select 2
  * (nCS2). This is the mapping for it.
  *
- * In jumpered boot mode, nCS2 is mapped to 0x5000000, not 0x2000000. This 
+ * In jumpered boot mode, nCS2 is mapped to 0x5000000, not 0x2000000. This
  * was cause for much consternation and headscratching. This should probably
  * be made a compile/run time kernel option.
  */
@@ -177,6 +181,70 @@
 #endif /* CONFIG_ARCH_EDB7211 */
 
 
+#if defined (CONFIG_ARCH_ZIPLINE)
+/*
+ * The extra 8 lines of the keyboard matrix are wired to chip select 3 (nCS3)
+ * and repeat across it. This is the mapping for it.
+ *
+ * In jumpered boot mode, nCS3 is mapped to 0x4000000, not 0x3000000. This
+ * was cause for much consternation and headscratching. This should probably
+ * be made a compile/run time kernel option.
+ */
+#if 0
+#define ZIPLINE_PHYS_EXTKBD		CS3_PHYS_BASE	/* physical */
+
+#define ZIPLINE_VIRT_EXTKBD		(0xfd000000)	/* virtual */
+#endif
+/*
+ * The CS8900A ethernet chip has its I/O registers wired to chip select 2
+ * (nCS2). This is the mapping for it.
+ *
+ * In jumpered boot mode, nCS2 is mapped to 0x5000000, not 0x2000000. This
+ * was cause for much consternation and headscratching. This should probably
+ * be made a compile/run time kernel option.
+ */
+#define ZIPLINE_PHYS_CS8900A		CS3_PHYS_BASE	/* physical */
+
+#define ZIPLINE_VIRT_CS8900A		(0xfc000000)	/* virtual */
+
+
+/*
+ * The two flash banks are wired to chip selects 0 and 1. This is the mapping
+ * for them.
+ *
+ * nCS0 and nCS1 are at 0x70000000 and 0x60000000, respectively, when running
+ * in jumpered boot mode.
+ */
+#define ZIPLINE_PHYS_FLASH		CS0_PHYS_BASE	/* physical */
+
+#define ZIPLINE_VIRT_FLASH		(0xfb000000)	/* virtual */
+
+/*
+ * The Radio chip selects are wired to chip selects 1 and 2. This is the mapping
+ * for them.
+ */
+
+#define ZIPLINE_PHYS_RADIO_IO		CS1_PHYS_BASE	/* physical */
+
+#define ZIPLINE_VIRT_RADIO_IO		(0xfa000000)	/* virtual */
+
+#define ZIPLINE_PHYS_RADIO_CONFIG	CS2_PHYS_BASE	/* physical */
+
+#define ZIPLINE_VIRT_RADIO_CONFIG	(0xf9000000)	/* virtual */
+
+#define ZIPLINE_PHYS_SRAM_CONFIG		CS6_PHYS_BASE	/* physical */
+
+#define ZIPLINE_VIRT_SRAM_CONFIG		(0xf8000000)	/* virtual */
+
+#define FLASH_START      CS0_PHYS_BASE
+#define FLASH_SIZE       0x00200000
+#define FLASH_WIDTH      2
+
+#define ZIPLINE_VIRT_SDRAM_FRAMEBUFFER	0xF7000000
+#define ZIPLINE_PHYS_SDRAM_FRAMEBUFFER	0xC0000000
+#define ZIPLINE_SIZE_SDRAM_FRAMEBUFFER	0x00020000
+
+#endif /* CONFIG_ARCH_ZIPLINE */
 /*
  * Relevant bits in port D, which controls power to the various parts of
  * the LCD on the EDB7211.

