diff -urN linux-2.4.21/include/asm-arm/arch-clps711x/irq.h linux-2.4.21.zipit/include/asm-arm/arch-clps711x/irq.h
--- linux-2.4.21/include/asm-arm/arch-clps711x/irq.h	2002-08-02 20:39:45.000000000 -0400
+++ linux-2.4.21.zipit/include/asm-arm/arch-clps711x/irq.h	2004-04-20 12:53:31.000000000 -0400
@@ -18,3 +18,50 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 #define fixup_irq(i)	(i)
+
+#ifdef CONFIG_ARCH_ZIPLINE
+
+#include <asm/io.h>
+#include <asm/arch/hardware.h>
+
+
+static void zipline_mask_irq(unsigned int irq)
+{
+	if ( irq < 16 )
+		ep_writel(ep_readl(INTMR1) & ~(1 << irq), INTMR1);
+	else if ( irq < 32 )
+		ep_writel(ep_readl(INTMR2) & ~(1 << (irq - 16)), INTMR2);
+	else
+		ep_writel(ep_readl(INTMR3) & ~(1 << (irq - 32)), INTMR3);
+}
+
+
+static void zipline_unmask_irq(unsigned int irq)
+{
+	if ( irq < 16 )
+		ep_writel(ep_readl(INTMR1) | (1 << irq), INTMR1);
+	else if ( irq < 32 )
+		ep_writel(ep_readl(INTMR2) | (1 << (irq - 16)), INTMR2);
+	else
+		ep_writel(ep_readl(INTMR3) | (1 << (irq - 32)), INTMR3);
+}
+
+
+static __inline__ void zipline_init_irq(void)
+{
+	int i;
+
+	ep_writel(0, INTMR1);
+	ep_writel(0, INTMR2);
+	ep_writel(0, INTMR3);
+
+	for (i = 0; i < NR_IRQS; i++) {
+		irq_desc[i].valid	= 1;
+		irq_desc[i].probe_ok	= 1;
+		irq_desc[i].mask_ack	= zipline_mask_irq;
+		irq_desc[i].mask	= zipline_mask_irq;
+		irq_desc[i].unmask	= zipline_unmask_irq;
+	}
+}
+
+#endif /* CONFIG_ARCH_ZIPLINE */

