diff -urN -X dontdiff linux-2.4.21/drivers/i2c/i2c-guide.c linux-2.4.21.32/drivers/i2c/i2c-guide.c
--- linux-2.4.21/drivers/i2c/i2c-guide.c	2005-11-04 20:52:11.000000000 -0700
+++ linux-2.4.21.32/drivers/i2c/i2c-guide.c	2005-03-29 08:17:51.000000000 -0700
@@ -32,20 +32,20 @@
 #define DEB2(x) 	/* low level debugging - very slow 		*/
 #define DEBE(x)	x	/* error messages 				*/
 					/*  Pin Port  Inverted	name	*/
-#define I2C_SDA		0x08		/*  port B ctrl pin 3  	(inv)	*/
-#define I2C_SCL		0x04		/*  port B ctrl pin 2 	(inv)	*/
+#define I2C_SDA		0x40		/*  port B ctrl pin 3  	(inv)	*/
+#define I2C_SCL		0x80		/*  port B ctrl pin 2 	(inv)	*/
 
-#define I2C_SDAIN	0x08		/*  use the same pin with output	*/
-#define I2C_SCLIN	0x04		/*  use the same pin with output        */
+#define I2C_SDAIN	0x40		/*  use the same pin with output	*/
+#define I2C_SCLIN	0x80		/*  use the same pin with output        */
 
-#define I2C_DMASK	0xf7            /* inverse of I2C_SDA  */
-#define I2C_CMASK	0xfb            /* inverse of I2c_SCL  */
+#define I2C_DMASK	0xbf            /* inverse of I2C_SDA  */
+#define I2C_CMASK	0x7f            /* inverse of I2c_SCL  */
 
-#define PORTB_PIN0_SDA_OUTPUT 0x08               /* pin 3 direction  of port B output */
-#define PORTB_PIN0_SDA_INPUT  0xf7               /* pin 3 direction of port B input  */
+#define PORTB_PIN0_SDA_OUTPUT 0x40               /* pin 3 direction  of port B output */
+#define PORTB_PIN0_SDA_INPUT  0xbf               /* pin 3 direction of port B input  */
 
-#define PORTB_PIN1_SCL_OUTPUT 0x04               /* pin 2 direction of port B output  */
-#define PORTB_PIN1_SCL_INPUT  0xfb               /* pin 2 direction of port B input  */
+#define PORTB_PIN1_SCL_OUTPUT 0x80               /* pin 2 direction of port B output  */
+#define PORTB_PIN1_SCL_INPUT  0x7f               /* pin 2 direction of port B input  */
 
 int base = 0;
 #define DEFAULT_BASE PBDR
@@ -182,6 +182,11 @@
 	return 0;
 }
 
+void i2c_bitguide_cleanup(void)
+{
+    i2c_bit_del_bus(&bit_guide_ops);
+}
+
 EXPORT_NO_SYMBOLS;
 
 MODULE_AUTHOR("T. C. Song  <tsong@iders.ca>");
@@ -191,6 +196,7 @@
 MODULE_PARM(base, "i");
 
 module_init(i2c_bitguide_init);
+module_exit(i2c_bitguide_cleanup);
 /* for completeness, we should have a module_exit() function, but the
    GUIDE requires this to always be loaded.  If it is unloaded, the
    operation of the GUIDE is undefined.

