diff -urN -X dontdiff linux-2.4.21/drivers/video/clps711xfb.c linux-2.4.21.32/drivers/video/clps711xfb.c
--- linux-2.4.21/drivers/video/clps711xfb.c	2005-11-04 20:52:11.000000000 -0700
+++ linux-2.4.21.32/drivers/video/clps711xfb.c	2005-03-13 09:13:23.000000000 -0700
@@ -1,7 +1,10 @@
 /*
- *  linux/drivers/video/clps711xfb.c
+ *  linux/drivers/video/clps711x_fb.c
  *
- *  Copyright (C) 2000-2001 Deep Blue Solutions Ltd.
+ * Mods to support Zipit
+ *  Copyright (C) 2005 Ken McGuire
+ *
+ *  Original work Copyright (C) 2000-2001 Deep Blue Solutions Ltd.
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -17,7 +20,7 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
- *  Framebuffer driver for the CLPS7111 and EP7212 processors.
+ *  Framebuffer driver for the zipit IM devide based on clps711xfb.c.
  */
 #include <linux/module.h>
 #include <linux/kernel.h>
@@ -46,13 +49,6 @@
 
 #define CMAP_MAX_SIZE	16
 
-/* The /proc entry for the backlight. */
-static struct proc_dir_entry *clps7111fb_backlight_proc_entry = NULL;
-
-static int clps7111fb_proc_backlight_read(char *page, char **start, off_t off,
-		int count, int *eof, void *data);
-static int clps7111fb_proc_backlight_write(struct file *file, 
-		const char *buffer, unsigned long count, void *data);
 
 /*
  * LCD AC Prescale.  This comes from the LCD panel manufacturers specifications.
@@ -83,9 +79,8 @@
 	 * This isn't true on all machines, so we only do it on EDB7211.
 	 *  --rmk
 	 */
-	if (machine_is_edb7211() || machine_is_guidea07()) {
-		level = 15 - level;
-	}
+
+//		level = 15 - level;
 
 	shift = 4 * (regno & 7);
 	level <<= shift;
@@ -113,6 +108,7 @@
 	int err = 0;
 
 	/* no colormap allocated? */
+
 	if (!dcmap->len)
 		err = fb_alloc_cmap(dcmap, CMAP_MAX_SIZE, 0);
 
@@ -138,6 +134,7 @@
 	unsigned int lcdcon, syscon, pixclock;
 	int chgvar = 0;
 
+
 	if (var->activate & FB_ACTIVATE_TEST)
 		return 0;
 
@@ -209,7 +206,7 @@
 	display->ypanstep	= cfb->fb.fix.ypanstep;
 	display->ywrapstep	= cfb->fb.fix.ywrapstep;
 	display->can_soft_blank = 1;
-	display->inverse	= 0;
+	display->inverse	= 0; /* Applies to MFB only */
 
 	cfb->fb.var		= *var;
 	cfb->fb.var.activate	&= ~FB_ACTIVATE_ALL;
@@ -271,6 +268,7 @@
 static int
 gen_get_cmap(struct fb_cmap *cmap, int kspc, int con, struct fb_info *info)
 {
+
 	fb_copy_cmap(&info->cmap, cmap, kspc ? 0 : 2);
 	return 0;
 }
@@ -282,6 +280,7 @@
 gen_get_fix(struct fb_fix_screeninfo *fix, int con, struct fb_info *info)
 {
 	*fix = info->fix;
+
 	return 0;
 }
 
@@ -292,6 +291,7 @@
 gen_get_var(struct fb_var_screeninfo *var, int con, struct fb_info *info)
 {
 	*var = info->var;
+
 	return 0;
 }
 
@@ -350,96 +350,16 @@
 }
 
 static void clps7111fb_blank(int blank, struct fb_info *info)
-{
-    	if (blank) {
-		if (machine_is_edb7211()) {
-			/* Turn off the LCD backlight. */
-			clps_writeb(clps_readb(PDDR) & ~EDB_PD3_LCDBL, PDDR);
-
-			/* Power off the LCD DC-DC converter. */
-			clps_writeb(clps_readb(PDDR) & ~EDB_PD1_LCD_DC_DC_EN, PDDR);
-
-			/* Delay for a little while (half a second). */
-			udelay(100);
-
-			/* Power off the LCD panel. */
-			clps_writeb(clps_readb(PDDR) & ~EDB_PD2_LCDEN, PDDR);
-
-			/* Power off the LCD controller. */
-			clps_writel(clps_readl(SYSCON1) & ~SYSCON1_LCDEN, 
-					SYSCON1);
-		}
-	} else {
-		if (machine_is_edb7211()) {
-			/* Power up the LCD controller. */
-			clps_writel(clps_readl(SYSCON1) | SYSCON1_LCDEN,
-					SYSCON1);
-
-			/* Power up the LCD panel. */
-			clps_writeb(clps_readb(PDDR) | EDB_PD2_LCDEN, PDDR);
-
-			/* Delay for a little while. */
-			udelay(100);
-
-			/* Power up the LCD DC-DC converter. */
-			clps_writeb(clps_readb(PDDR) | EDB_PD1_LCD_DC_DC_EN,
-						PDDR);
+{ 
 
-			/* Turn on the LCD backlight. */
-			clps_writeb(clps_readb(PDDR) | EDB_PD3_LCDBL, PDDR);
-		}
-	}
-}
-
-static int 
-clps7111fb_proc_backlight_read(char *page, char **start, off_t off,
-		int count, int *eof, void *data)
-{
-	/* We need at least two characters, one for the digit, and one for
-	 * the terminating NULL. */
-	if (count < 2) 
-		return -EINVAL;
+//    if (blank) {
+//        clps_writel(clps_readl(SYSCON1) & ~SYSCON1_LCDEN, SYSCON1);
+//    } else {
+//        clps_writel(clps_readl(SYSCON1) | SYSCON1_LCDEN, SYSCON1);
+//    }	
 
-	if (machine_is_edb7211()) {
-		return sprintf(page, "%d\n", 
-				(clps_readb(PDDR) & EDB_PD3_LCDBL) ? 1 : 0);
-	}
-
-	return 0;
 }
 
-static int 
-clps7111fb_proc_backlight_write(struct file *file, const char *buffer, 
-		unsigned long count, void *data)
-{
-	unsigned char char_value;
-	int value;
-
-	if (count < 1) {
-		return -EINVAL;
-	}
-
-	if (copy_from_user(&char_value, buffer, 1)) 
-		return -EFAULT;
-
-	value = char_value - '0';
-
-	if (machine_is_edb7211()) {
-		unsigned char port_d;
-
-		port_d = clps_readb(PDDR);
-
-		if (value) {
-			port_d |= EDB_PD3_LCDBL;
-		} else {
-			port_d &= ~EDB_PD3_LCDBL;
-		}
-
-		clps_writeb(port_d, PDDR);
-	}
-
-	return count;
-}
 
 static void __init clps711x_guess_lcd_params(struct fb_info *info)
 {
@@ -459,6 +379,7 @@
 	 * If the LCD controller is already running, decode the values
 	 * in LCDCON to xres/yres/bpp/pixclock/acprescale
 	 */
+
 	syscon = clps_readl(SYSCON1);
 	if (syscon & SYSCON1_LCDEN) {
 		lcdcon = clps_readl(LCDCON);
@@ -512,9 +433,9 @@
 	 * CLPS7110 - no on-board SRAM
 	 * EP7212   - 38400 bytes
 	 */
-	if (size <= 38400) {
-		printk(KERN_INFO "CLPS711xFB: could use on-board SRAM?\n");
-	}
+//	if (size <= 38400) {
+//		printk(KERN_INFO "CLPS711xFB: could use on-board SRAM?\n");
+//	}
 
 	if ((syscon & SYSCON1_LCDEN) == 0) {
 		/*
@@ -530,9 +451,10 @@
 	info->fix.type       = FB_TYPE_PACKED_PIXELS;
 }
 
-/* this function initializes the LCD registers as required by the Guide A07
+/* this function initializes the LCD registers as required for the SRAM Frame Buffer
 */
-int __init clps711xfb_guidea07_init(void)
+
+int __init clps711xfb_sram_init(void)
 {
 	unsigned long videomem, videosize;
 	unsigned int lcdcon, syscon;
@@ -541,9 +463,9 @@
 	syscon = clps_readl(SYSCON1);
 	clps_writel(syscon & ~SYSCON1_LCDEN, SYSCON1);
 
-	printk(KERN_INFO "CLPS711xFB: setting up cs89712 SRAM as QVGA video framebuffer\n");
-	clps_writel(0x6, FBADDR); //internal SRAM location
-	videomem = (unsigned long)ioremap(SRAM_START, SRAM_SIZE);
+	printk(KERN_INFO "CLPS711xFB: SRAM FB\n");
+	clps_writel(FB_SEG, FBADDR); //internal SRAM location
+	videomem = (unsigned long)ioremap(ZIPLINE_PHYS_SRAM_CONFIG,SRAM_SIZE);
 	if (!videomem) {
 		printk("ioremap failed!\n");
 		kfree(cfb);
@@ -554,7 +476,7 @@
 	memset((void *)videomem, 0, videosize); //clear the vid memory
 
 	cfb->fb.screen_base     = (void *)videomem;
-	cfb->fb.fix.smem_start  = SRAM_START; //must be physical address
+	cfb->fb.fix.smem_start  = ZIPLINE_PHYS_SRAM_CONFIG; //must be physical address
 	cfb->fb.fix.smem_len    = videosize;
 
 	cfb->fb.var.grayscale   = 1;
@@ -567,6 +489,7 @@
 	lcdcon |= LCDCON_GSMD | LCDCON_GSEN; //4bpp
         //lcdcon |= 5 << 19;	//pixel prescale value (pixclock)
 	//lcdcon |= 13 << 25;	//AC prescale value
+
 	clps_writel(lcdcon, LCDCON);
 
 	//reenable LCD
@@ -580,6 +503,7 @@
 	int err = -ENOMEM;
 
 	cfb = kmalloc(sizeof(*cfb) + sizeof(struct display), GFP_KERNEL);
+
 	if (!cfb)
 		goto out;
 
@@ -602,50 +526,13 @@
 
 	clps711x_guess_lcd_params(&cfb->fb);
 
-	if (machine_is_guidea07()) {
-		clps711xfb_guidea07_init();
-	}
-
-	if (machine_is_fortunet()) {
-		cfb->fb.fix.smem_len = 0x20000;
-	}
+	clps711xfb_sram_init();
 
 	fb_alloc_cmap(&cfb->fb.cmap, CMAP_MAX_SIZE, 0);
 
-	/* Register the /proc entries. */
-	clps7111fb_backlight_proc_entry = create_proc_entry("backlight", 0444,
-		&proc_root);
-	if (clps7111fb_backlight_proc_entry == NULL) {
-		printk("Couldn't create the /proc entry for the backlight.\n");
-		return -EINVAL;
-	}
-
-	clps7111fb_backlight_proc_entry->read_proc = 
-		&clps7111fb_proc_backlight_read;
-	clps7111fb_backlight_proc_entry->write_proc = 
-		&clps7111fb_proc_backlight_write;
-
 	/*
 	 * Power up the LCD
 	 */
-	if (machine_is_p720t()) {
-		PLD_LCDEN = PLD_LCDEN_EN;
-		PLD_PWR |= (PLD_S4_ON|PLD_S3_ON|PLD_S2_ON|PLD_S1_ON);
-	}
-
-	if (machine_is_edb7211()) {
-		/* Power up the LCD panel. */
-		clps_writeb(clps_readb(PDDR) | EDB_PD2_LCDEN, PDDR);
-
-		/* Delay for a little while. */
-		udelay(100);
-
-		/* Power up the LCD DC-DC converter. */
-		clps_writeb(clps_readb(PDDR) | EDB_PD1_LCD_DC_DC_EN, PDDR);
-
-		/* Turn on the LCD backlight. */
-		clps_writeb(clps_readb(PDDR) | EDB_PD3_LCDBL, PDDR);
-	}
 
 	clps7111fb_set_var(&cfb->fb.var, -1, &cfb->fb);
 	err = register_framebuffer(&cfb->fb);
@@ -661,10 +548,6 @@
 	/*
 	 * Power down the LCD
 	 */
-	if (machine_is_p720t()) {
-		PLD_LCDEN = 0;
-		PLD_PWR &= ~(PLD_S4_ON|PLD_S3_ON|PLD_S2_ON|PLD_S1_ON);
-	}
 }
 
 #ifdef MODULE

