#############################################################
#
# ZipIt command line utils to install images into  Flash.
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_ZIPIT_LOADER)),y)

ZIPIT_LOADER_PACKAGE=zipit-loader-1.2
ZIPIT_LOADER_SOURCE=$(ZIPIT_LOADER_PACKAGE).tar.bz2
ZIPIT_LOADER_SITE=http://www.openzipit.org/Downloads/files/
ZIPIT_5WIRE_LOADER=$(TOPDIR)/5wire_loader
ZIPIT_LOADER_BIN=$(TOPDIR)/loader.bin
ZIPIT_ZPM_BIN=$(TOPDIR)/zpm.bin
ZIPIT_5WIRE_PROGRAM=$(TOPDIR)/5wire_loader
ZIPIT_LOADER_DIR=$(BUILD_DIR)/$(ZIPIT_LOADER_PACKAGE)

TARGET_OBJCOPY=$(STAGING_DIR)/bin/arm-linux-objcopy

$(DL_DIR)/$(ZIPIT_LOADER_SOURCE):
	$(WGET) -P $(DL_DIR) $(ZIPIT_LOADER_SITE)/$(ZIPIT_LOADER_SOURCE)

$(ZIPIT_LOADER_DIR)/.source: $(DL_DIR)/$(ZIPIT_LOADER_SOURCE)
	bzcat $(DL_DIR)/$(ZIPIT_LOADER_SOURCE) | tar -C $(BUILD_DIR) -xvf -
	touch $(ZIPIT_LOADER_DIR)/.source

$(ZIPIT_LOADER_DIR): $(ZIPIT_LOADER_DIR)/.source

$(ZIPIT_ZPM_BIN): $(ZIPIT_LOADER_DIR)
	$(MAKE) CC=$(TARGET_CC) OBJCOPY=$(TARGET_OBJCOPY) LD=$(TARGET_LD) \
		TOPDIR=$(TOPDIR) ZIPIT_ZPM_BIN=$(ZIPIT_ZPM_BIN) \
	  -C $(ZIPIT_LOADER_DIR) $(ZIPIT_ZPM_BIN)

$(ZIPIT_LOADER_BIN): $(ZIPIT_LOADER_DIR)
	$(MAKE) CC=$(TARGET_CC) OBJCOPY=$(TARGET_OBJCOPY) LD=$(TARGET_LD) \
		TOPDIR=$(TOPDIR) ZIPIT_LOADER_BIN=$(ZIPIT_LOADER_BIN) \
	  -C $(ZIPIT_LOADER_DIR) $(ZIPIT_LOADER_BIN)

$(ZIPIT_5WIRE_PROGRAM): $(ZIPIT_LOADER_DIR)
		$(MAKE) TOPDIR=$(TOPDIR) ZIPIT_5WIRE_PROGRAM=$(ZIPIT_5WIRE_PROGRAM) \
 -C $(ZIPIT_LOADER_DIR) $(ZIPIT_5WIRE_PROGRAM)

zipit-loader: $(ZIPIT_LOADER_BIN) $(ZIPIT_ZPM_BIN) $(ZIPIT_5WIRE_PROGRAM)

TARGETS+=zipit-loader

zipit-loader-clean:
	@rm -f $(ZIPIT_LOADER_BIN) $(ZIPIT_ZPM_BIN) $(ZIPIT_5WIRE_PROGRAM)
	@rm -rf $(ZIPIT_LOADER_DIR)

endif

