#############################################################
#
# various ZipIt command line utils
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_ZIPIT_UTILS)),y)

ZIPIT_UTILS_NAME=zipit-utils

ZIPIT_UTILS_PACKAGE:=$(ZIPIT_UTILS_NAME)-1.0
ZIPIT_UTILS_SOURCE:=$(ZIPIT_UTILS_PACKAGE).tar.bz2
ZIPIT_UTILS_SITE:=http://www.openzipit.org/Downloads/files/

ZIPIT_UTILS_SYMTARGET:=/usr/sbin/
ZIPIT_UTILS_DIR:=$(BUILD_DIR)/$(ZIPIT_UTILS_PACKAGE)
ZIPIT_UTILS_TARGET:=$(TARGET_DIR)$(ZIPIT_UTILS_SYMTARGET)
ZIPIT_UTILS_BINARY:=$(ZIPIT_UTILS_TARGET)$(ZIPIT_UTILS_NAME)

$(DL_DIR)/$(ZIPIT_UTILS_SOURCE):
	$(WGET) -P $(DL_DIR) $(ZIPIT_UTILS_SITE)/$(ZIPIT_UTILS_SOURCE)

$(ZIPIT_UTILS_DIR)/.source: $(DL_DIR)/$(ZIPIT_UTILS_SOURCE)
	bzcat $(DL_DIR)/$(ZIPIT_UTILS_SOURCE) | tar -C $(BUILD_DIR) -xvf -
	touch $(ZIPIT_UTILS_DIR)/.source

ZIPIT_UTILITY_BINARY:
	$(MAKE) TOPDIR=$(TOPDIR) ZIPIT_UTILS_BINARY=$(ZIPIT_UTILS_BINARY) \
		CC=$(TARGET_CC) CFLAGS="$(TARGET_CFLAGS)" STRIP=$(TARGET_CROSS)strip \
		ZIPIT_UTILS_DIR=$(ZIPIT_UTILS_DIR) \
		ZIPIT_UTILS_SYMTARGET=$(ZIPIT_UTILS_SYMTARGET) \
		ZIPIT_UTILS_TARGET=$(ZIPIT_UTILS_TARGET) \
		ZIPIT_UTILS_NAME=$(ZIPIT_UTILS_NAME) \
		-C $(ZIPIT_UTILS_DIR) zipit_utils

zipit-utils: $(ZIPIT_UTILS_DIR)/.source ZIPIT_UTILITY_BINARY

zipit-utils-clean:
	$(MAKE) -C $(ZIPIT_UTILS_DIR) zipit_utils_clean

TARGETS+=zipit-utils

endif

